program cubes( input, output, dat, out );

type
   longint = integer;
   box = record x, y, z, dx, dy, dz : longint end;

procedure readcube( var f : text; var b : box );

   begin
   with b do
      begin
      readln( f, x, y, z, dx );
      dy := dx;
      dz := dx
      end
   end;

function max( a, b : longint ) : longint;

   begin
   if a > b then max := a else max := b
   end;

procedure intersect( a, b : box; var c : box );

   begin
   c.x := max( a.x, b.x );
   c.dx := max( 0, ((a.dx + b.dx ) - abs( a.x - b.x ) - abs((a.x + a.dx) - (b.x + b.dx)) ) div 2 );
   c.y := max( a.y, b.y );
   c.dy := max( 0, ((a.dy + b.dy ) - abs( a.y - b.y ) - abs((a.y + a.dy) - (b.y + b.dy)) ) div 2 );
   c.z := max( a.z, b.z );
   c.dz := max( 0, ((a.dz + b.dz ) - abs( a.z - b.z ) - abs((a.z + a.dz) - (b.z + b.dz)) ) div 2 );
   end;

var
   dat, out : text;
   n, i : longint;
   b1, b2 : box;

begin
reset( dat, 'cubes.in' );
rewrite( out, 'cubes.out' );
readln( dat, n );
while n > 0 do
   begin
   readcube( dat, b1 );
   for i := 2 to n do
      begin
      readcube( dat, b2 );
      intersect( b1, b2, b1 )
      end;
   writeln( out, b1.dx * b1.dy * b1.dz );
   readln( dat, n )
   end;
close( out );
close( dat )
end.
